/*
 * Simulator of MCS51 (simcl.h)
 *
 * Copyright (C) 1999,99 Drotos Daniel, Talker Bt.
 * 
 * To contact author send email to drdani@mazsola.iit.uni-miskolc.hu
 *
 */

/* This file is part of MCS51 simulator: s51.

S51 is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

S51 is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with S51; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA. */
/*@1@*/

#ifndef SIMCL_HEADER
#define SIMCL_HEADER

#include <stdio.h>

#include "pobjcl.h"

#include "cmdcl.h"

#include "uccl.h"


class cl_prg_arg: public cl_base
{
public:
  char short_name;
  char *long_name;
  long long l_value;
  char *s_value;

public:
  cl_prg_arg(char sn, char *ln, long long lv, char *sv);
  ~cl_prg_arg(void);

  virtual long long get_lvalue(void);
  virtual char *get_svalue(void);
};


class cl_sim: public cl_base
{
public:
  int argc; char **argv;

  class cl_cmd *cmd;
  class cl_uc *uc;
  FILE *cmd_in;		// Command console input
  FILE *cmd_out;	// Command console output
  char *accept_args;
  class cl_list *arguments;

public:
  cl_sim(char *more_args, int iargc, char *iargv[]);
  //cl_sim(class cl_uc *auc);
  ~cl_sim(void);
  virtual int init(void);
  
  virtual int proc_arguments(int argc, char *argv[]);
  virtual int proc_arg(char arg, char *optarg);

  virtual class cl_cmd *mk_commander(char *con_in, char *con_out);
  virtual class cl_uc *mk_controller(void);

  virtual long long get_larg(char name);
  virtual char *get_sarg(char name);

  virtual int do_cmd(void);

};


#endif

/* End of simcl.h */
